! calcualting pressure based on scale by Wu et al (JGR 2008)
PROGRAM scale

  IMPLICIT NONE

  INTEGER, PARAMETER :: DP = selected_real_kind(14,200)

  real(DP):: Cv(5),Ck(5),Cp(5),Ca(5)

  real(DP):: T,V,a0,P
  integer:: i
  integer:: num ! numbers of the point need to be calculated
! coefficient for calculating V_0
  Cv(1)=74.185
  Cv(2)=1.550
  Cv(3)=1.397
  Cv(4)=-0.385
  Cv(5)=0.0602

! coefficient for calculating K_0
  Ck(1)=168.80
  Ck(2)=-23.22
  Ck(3)=-3.573
  Ck(4)=1.107
  Ck(5)=-0.125

! coefficient for calculating 
! K_prime(pressure derivative of bulk modulus)
  Cp(1)=4.2516
  Cp(2)=0.1442
  Cp(3)=0.0495
  Cp(4)=-0.0195
  Cp(5)=0.00404

! coefficient for calculating A
  Ca(1)=-0.1526
  Ca(2)=-0.0769
  Ca(3)=-0.0022
  Ca(4)=0.00248
  Ca(5)=-0.0006542
 

 open(unit=1,file="inputVT.txt")
 open(unit=10,file="outputPVT.txt")
 read(1,*)num
 write(10,*)"#Pressure based on MgO scale (Wu et al JGR 2008)"
 write(10,*)"Temperature(K)  lattice const.(A)    volume    pressure (GPa) "
 do i=1,num
  read(1,*)T,a0
  V=a0**3.0
  call getpressure(V,T,P,Cv,Ck,Cp,Ca) 
  write(10,'(1f14.2,3f15.6)')T,a0,V,P
 enddo  

 end



SUBROUTINE getpressure(V,Temp,P,Cv,Ck,Cp,Ca)

 IMPLICIT NONE

 INTEGER, PARAMETER :: DP = selected_real_kind(14,200)

 real(DP):: Cv(5),Ck(5),Cp(5),Ca(5)

 real(DP):: V0,K0,Kp,A,V,T,P,term2,term3,Ra,Temp  

 integer:: i 

 T=Temp/1000.0


  V0=0.0
  K0=0.0
  Kp=0.0
  A=0.0

  do i=1,5
   V0=V0+Cv(i)*T**(i-1)   
   K0=K0+Ck(i)*T**(i-1)   
   Kp=Kp+Cp(i)*T**(i-1)   
   A=A+Ca(i)*T**(i-1)   
  enddo
 ! write(10,*)V0,K0,Kp,A
   Ra=(V0/V)**(1.0/3.0)
   term2=0.75*(Kp-4.0)*(Ra**2.0-1.0)
   term3=A*(Ra**2.0-1.0)**2.0
   P=1.5*K0*(Ra**7.0-Ra**5.0)*(1.0+term2+term3)
 !  write(10,*)Ra,term2,term3,P 

    Return
END SUBROUTINE getpressure
